chrome.runtime.onInstalled.addListener(function (details) {
	try {
		if (details.reason == "install") {
			chrome.tabs.create({ url: "html/settings.html" });
		}
		else if (details.reason == "update") {
			var thisVersion = chrome.runtime.getManifest().version;
		}
	} catch (err) {
		console.log(err);
	}
});

var crm;
var agile_pusher;
var USER_SETTINGS = {};

var notification_prefs = {};

var notif_types = ['IS_BROWSING', 'OPENED_EMAIL', 'CLICKED_LINK', 'DEAL_CREATED', 'DEAL_CLOSED', 'TAG_ADDED', 'TAG_DELETED', 'CONTACT_ADDED', 'CONTACT_DELETED', 'CAMPAIGN_NOTIFY'];

/**
	When started, read USER_SETTINGS from storage.
**/
$(function () {
	// Wait for 1 Min for chrome to load the data.
	//setTimeout(function(){loadSettings();}, 1000);
	console.log("--------loadSettings------");
	loadSettings();
	var isInstalledNode = document.createElement('div');
	isInstalledNode.id = 'extension-is-installed';
	document.body.appendChild(isInstalledNode);
});

/**
 * Load settings from the local storage.
 */
function loadSettings() {
	chrome.storage.local.get(null, function (item) {
		//console.log('Items-- : ',item);
		USER_SETTINGS = item.USER_SETTINGS;
		// console.log('USER_SETTINGS', USER_SETTINGS);
		if (USER_SETTINGS) {
			crm = new CRMConnector();
			// console.log("crm.init_status", crm.init_status);

			if (!crm.init_status) { crm = undefined; return; }
			//console.log('GET-subscribe to pusher.');
			//unsubscribeToPusher();
			subscribeToPusher(USER_SETTINGS.domain);
			getNotificationPrefs();
		}
	});
}

/**
	When USER_SETTINGS is changed, reload from storage.
**/
chrome.storage.onChanged.addListener(function (changes, namespace) {
	//console.log('changes - ',changes);
	try {
		if (changes.USER_SETTINGS) {
			USER_SETTINGS = changes.USER_SETTINGS.newValue;

			if (USER_SETTINGS) {
				crm = new CRMConnector();
				if (!crm.init_status) { crm = undefined; return; }
				//console.log('LISTNER-subscribe to pusher.');
				//unsubscribeToPusher();
				//subscribeToPusher(USER_SETTINGS.domain);
				getNotificationPrefs();
				loadSettings();

				// console.log(changes);

				loadTrackingStorage(USER_SETTINGS.domain);

				// Remove old Notifications when the user changed credentials.
				var newValues = changes.USER_SETTINGS.newValue;
				var oldValues = changes.USER_SETTINGS.oldValue;

				if (oldValues && newValues && newValues.email != oldValues.email)
					chrome.storage.local.remove('agile_notifications', function () {
						//console.log('Removed Old Notifications');
					});
			}
		}
	} catch (err) {
		console.log(err);
	}
});

var tabBlock = {};
var settings = {}; // USER_Settings from message

var urlBlock = '<none>';

// To stop tracking the email sent when the sender opened it.
chrome.webRequest.onBeforeRequest.addListener(function (details) {
	try {
		var trackImage = 'fr=' + USER_SETTINGS.email;
		//console.log(details.url.indexOf(trackImage));
		return { cancel: details.url.indexOf(trackImage) > -1 };
	} catch (err) {
		console.log(err);
		return '';
	}
},
	{ urls: ["*://*.googleusercontent.com/*"] }, ["blocking"]);


chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	try {
		//console.log(request);
		//if(request.from!=='_crmio_gmail_content')return;

		if (request.msg === 'register') {
			tabBlock[sender.tab.id] = true;
			urlBlock = getBlockingImageUrl(USER_SETTINGS);
			sendResponse({ ok: true });
		}
		else if (request.msg == 'unregister') {
			delete tabBlock[sender.tab.id];
			sendResponse({ ok: true });
		}
		else if (request.msg == 'email_details') {
			$.ajax({
				method: "POST",
				url: "https://agilecrmio.appspot.com/core/email-details",
				data: "type=EMAIL_DETAILS&content=" + encodeURIComponent(JSON.stringify(request.content)),
				success: function () {
					//console.log('Success : Info of email sent to CRMio Server'); 
				},
				error: function (jqXHR, textStatus, errorThrown) {
					//console.log("FAILED : Can't send info of email to CRMio Server");
				}
			});
		} else if (request.msg == 'contact_dialog') {
			request.data.countrycode = countryCode2Name;
			var html = getHTML(request.template, request.data);
			//console.log('Sending html content.');
			sendResponse({ dialog: html });
		} else if (request.msg == 'contact_form') {
			var html = getHTML(request.template, '');
			//console.log('Sending html content.');
			sendResponse({ dialog: html });
		}
	} catch (err) {
		console.log(err);
	}
});

function getNotificationPrefs() {
	//console.log('Loading prefs.');
	crm.loadSimpleUrl(crm.base_url + 'notifications', function (response) {
		//console.log(response);
		// Get the notification rules from the site and save locally.
		notification_prefs = response;
		chrome.storage.local.set({ 'notification_prefs': notification_prefs }, function () {
			//console.log(chrome.runtime.lastError);
			//console.log('User settings saved.');

		});
	});
}

function loadTrackingStorage(domain) {
	crm = new CRMConnector();
	_agileGetStorageVal("sendEmails", function (result) {
		console.log(result.sendEmails);
		if (!result.sendEmails || result.sendEmails.length == 0) {
			sendEmails = [];
			console.log("load trakcing msgsd");
			console.log("In loop " + result.sendEmails);
			/*crm.getEmailTrackers(crm.base_url+'email-tracker/getThreadIds',function(responses){
			  for(var i=0;i<responses.length;i++){
				sendEmails.push([responses[i].thread_id,responses[i].is_read]);
				chrome.storage.local.set({sendEmails: sendEmails}, function () {});
			  }
			});*/
			$.ajax({
				type: "GET",
				url: "https://" + domain + ".agilecrm.com/dev/api/email-tracker/getThreadIds",
				dataType: 'json',
				success: function (responses) {
					console.log(responses);
					if (sendEmails.length == 0) {
						for (var i = 0; i < responses.length; i++) {
							sendEmails.push([responses[i].thread_id, responses[i].is_read]);
						}
						console.log("sendEmails =  " + sendEmails);
					}
					chrome.storage.local.set({ sendEmails: sendEmails }, function () { });

					chrome.storage.local.get('sendEmails', function (result) {
						console.log("resulted mails = " + result.sendEmails);
					});
				},
				error: function (jqXHR, textStatus, errorThrown) {

				}
			});
		}
	});

}


function showNotifications(message) {
	var contact_link = '<a href="https://' + message.domain + '.agilecrm.com/#contact/' + message.id + '" id="notification-contact-id" style="color:black;font-weight:bold;">' + getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name') + '</a>';
	var contact_name = '';

	if (message.type = 'PERSON') {
		contact_name = getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name');
	} else {
		contact_name = getPropertyValue(message.properties, 'name');
	}

	var opt = {
		type: "basic",
		title: contact_name,
		message: getNotifInfo(message),
		iconUrl: getGravatarImage(message.properties, 50)
	}
	console.log(opt);

	// Create a simple text notification:
	chrome.notifications.create("", opt, function (id) {
		//console.log('----id----',id);
		chrome.notifications.onClicked.addListener(function (id) {
			Window.location.href = contact_link;
		});
		if (id)
			setTimeout(function () {
				chrome.notifications.clear(id, function () { });
			}, 6000);

	});
}

function showCallNotifications(message) {
	var contact_link = '<a href="https://' + message.domain + '.agilecrm.com/#contact/' + message.id + '" id="notification-contact-id" style="color:black;font-weight:bold;">' + getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name') + '</a>';
	var contact_name = getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name');
	var opt = {
		type: "basic",
		title: 'Call',
		message: contact_name + ' is calling.',
		iconUrl: getGravatarImage(message.properties, 50)
	}
	// Create a simple text notification:
	chrome.notifications.create("", opt, function (id) {
		//console.log('----id----',id);
		chrome.notifications.onClicked.addListener(function (id) {
			Window.location.href = contact_link;
		});
	});
}

function showCampaignNotifications(message) {
	var contact_link = '<a href="https://' + message.domain + '.agilecrm.com/#contact/' + message.id + '" id="notification-contact-id" style="color:black;font-weight:bold;">' + getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name') + '</a>';
	var contact_name = getPropertyValue(message.properties, 'first_name') + ' ' + getPropertyValue(message.properties, 'last_name');
	var opt = {
		type: "basic",
		title: contact_name,
		message: message.custom_value.msg,
		iconUrl: getGravatarImage(message.properties, 50)
	}
	// Create a simple text notification:
	chrome.notifications.create("", opt, function (id) {
		//console.log('----id----',id);
		chrome.notifications.onClicked.addListener(function (id) {
			Window.location.href = contact_link;
		});
	});
}

/**
 * Sets notification message
 * 
 * @param message
 *            message from the Pusher channel.
 */
function _setupNotification(message) {
	if (message.notification == 'CALL') {
		console.log(" CALL *** ");
		showCallNotifications(message);
	} else if (message.notification == 'CAMPAIGN_NOTIFY') {
		console.log(" CAMPAIGN_NOTIFY *** ");
		showCampaignNotifications(message);
	} else {
		console.log(" OTHER *** ");
		showNotifications(message);
	}
}

/**
 * Decide which url to block depending on sets -> USER_SETTINGS
 */
function getBlockingImageUrl(sets) {
	return sets.domain;
}

function initNotifications(message, onInit) {
	var agileNotifications = [];
	agileNotifications.push(message);
	chrome.storage.local.set({ 'agile_notifications': agileNotifications }, function () {
		if (onInit) onInit();
	});
}

/**
 * Verifies whether contact owner is same as notification prefs owner. It is
 * used for 'CONTACT_ASSIGNED' option.
 * 
 * @param contact -
 *            contact object.
 */
function is_assigned(contact) {

	// Current user who logged_in
	var current_user = notification_prefs.prefs.currentDomainUserName;

	// User who created contact
	var contact_created_by = contact.owner_name;

	// checks for assigned contact
	if (current_user == contact_created_by)
		return true;

	return false;
}

/**
 * Verifies whether contact is assigned and starred (having star value).
 * 
 * @param contact -
 *            contact object.
 */
function is_assigned_and_starred(contact) {

	// checks assigned and starred
	if (is_assigned(contact) && contact.star_value > 0)
		return true;

	return false;
}

/**
 * Shows notification for link clicked, email opened and browsing. It verifies
 * for option selected and shows notification accordingly.
 */
function verifyContact(contact, option) {	//console.log(option, contact);
	switch (option) {
		case 'CONTACT_ASSIGNED':
			return is_assigned(contact);
		case 'CONTACT_ASSIGNED_AND_STARRED':
			return is_assigned_and_starred(contact);
		case 'ANY_CONTACT':
			return true;
	}

}

/**
 * Verify whether the user asked for this type of notifications.
 */
function verifyRules(message) {
	if (message.type == 'BULK_ACTIONS' || !notification_prefs.control_notifications || !message.notification)
		return false;
		
	switch (message.notification) {
		case "IS_BROWSING":
			return verifyContact(message, notification_prefs.browsing);

		case "CLICKED_LINK":
			return verifyContact(message, notification_prefs.link_clicked);

		case "OPENED_EMAIL":
			//console.log(verifyContact(message, notification_prefs.email_opened));
			return verifyContact(message, notification_prefs.email_opened);

		case "CONTACT_ADDED":
			return notification_prefs.contact_added;

		case "CONTACT_DELETED":
			//return notification_prefs.contact_deleted;
			return false;

		case "DEAL_CREATED":
			return notification_prefs.deal_created;

		case "DEAL_CLOSED":
			return notification_prefs.deal_closed;

		case "TAG_ADDED":
			return notification_prefs.tag_added;

		case "TAG_DELETED":
			return notification_prefs.tag_deleted;

		default:
			return true;
	}
}

/* function unsubscribeToPusher()
{	if(USER_SETTINGS.oldDomain){
	//console.log('---old domain--', USER_SETTINGS.oldDomain);
		//pubnub.unsubscribe({channel : USER_SETTINGS.oldDomain});
		//}
// 		pubnub.where_now({
//      uuid     : 'my_uuid',
//      callback : function(m){//console.log(m)},
//      error : function(m){//console.log(m)}
//  });
} */
/**
 * Subscribes to Pubnub.
 * 
 * @param domain -
 *            Domain name.
 */
function subscribeToPusher(domain) {
	console.log('Subscribe to pusher.--------', domain + " : " + agile_pusher);
	try {
		if (agile_pusher)
			return;

		//chrome.storage.local.remove('agile_notifications', function(){//console.log('removed--------------');});
		// var pubnub = PUBNUB.init({ 'publish_key' : 'pub-c-e4c8fdc2-40b1-443d-8bb0-2a9c8facd274','subscribe_key' : 'sub-c-118f8482-92c3-11e2-9b69-12313f022c90', ssl : true, origin : 'pubsub.pubnub.com' });
		// pubnub.ready();
		// pubnub.subscribe({ channel : domain, callback : function(message)
		// {	//console.log('noty',message);
		// 	//console.log(verifyRules(message));
		// 	try{
		// 		if(verifyRules(message)){
		// 			handlePubnubCallback(message);
		// 		}
		// 	} catch(e){
		// 		console.log(e);
		// 	}
		// } });

		var protocol = 'https';
		Pusher.logToConsole = false;
		var pusher = new Pusher('552f74219141c9585d02', {
			cluster: 'mt1',
			forceTLS: true,
			authEndpoint: 'https://' + USER_SETTINGS.domain + '.agilecrm.com/dev/api/pusher/notification_auth',
			disableStats: true,
			auth: {
				headers: { Authorization: "xx " + btoa(USER_SETTINGS.email + ':' + USER_SETTINGS.apikey) }
			}
		});


		var channel = pusher.subscribe('presence-' + domain);
		channel.bind('pusher:subscription_succeeded', function (message) {
			console.log("pusher is subscription success")
		});

		channel.bind('client-notify-message', function (data) {
			console.log("pusher *** message");
			console.log(data);

			var message = "";
			try {
				message = JSON.parse(data);
				if (data.message !== undefined) {
					message = JSON.parse(data.message)
				}
			}
			catch (err) {
				message = data;
				if (data.message !== undefined) {
					message = data.message
				}
			}
			
			console.log(verifyRules(message));

			try {
				if (verifyRules(message)) {
					handlePusherCallback(message);
				}
			} catch (e) {
				console.log(e);
			}
		});

		agile_pusher = pusher;

	} catch (err) {
		console.log(err);
	}
}

var dopostqueue = $({});
function handlePusherCallback(message) {

	dopostqueue.queue(function () {

		message.domain = USER_SETTINGS.domain;
		message.notify_time = new Date().getTime();
		_setupNotification(message);

		var agileNotifications = [message];
		chrome.storage.local.get(function (item) {

			if (item.agile_notifications)
				$.merge(agileNotifications, item.agile_notifications);

			// If there are more than 20 messages, remove the old one and save the new ones.
			if (agileNotifications.length > 20)
				agileNotifications = agileNotifications.splice(0, 10);

			saveNotifications(agileNotifications, function () {
				dopostqueue.dequeue();
			});

		});
	});

}

function _agileGetStorageVal(key, callback) {
	chrome.storage.local.get(key, function (value) {
		if (callback)
			callback(value);
	});
}

/**
* Save the notifications in the chrome storage.
*/
function saveNotifications(agileNotifications, callback) {
	if (agileNotifications.length > 0)
		chrome.storage.local.set({ 'agile_notifications': agileNotifications }, function () {
			//console.log('Notifications saved.');
			try {
				chrome.browserAction.getBadgeText({}, function (result) {
					var obj = {};
					obj.text = (parseInt(result) + 1).toString();
					if (obj.text == 'NaN')
						obj.text = '1';
					chrome.browserAction.setBadgeText(obj);

					callback();
				});
			} catch (ex) {
			}
		});
}

chrome.contextMenus.removeAll(function () {

	chrome.contextMenus.create({
		id: "people_google",
		title: "Search People on Google",
		contexts: ["all"]
	});
	chrome.contextMenus.create({
		id: "companies_google",
		title: "Search Companies on Google",
		contexts: ["all"]
	});
	chrome.contextMenus.create({
		id: "email_search_agilecrm",
		title: "Search Email in Agile CRM",
		contexts: ["all"]
	});

});

chrome.contextMenus.onClicked.addListener(function (info, tab) {


	var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;



	if (info.menuItemId == "email_search_agilecrm") {

		if (info.selectionText == undefined) {
			if (info.linkUrl == undefined) {
				alert("please select email");
				return;
			}

		}
		if (info.linkUrl) {
			var inplink = info.linkUrl;
			if (inplink.indexOf("mailto:") != -1) {
				var strData = inplink.split("mailto:")[1];
				var emailInput = strData.trim();
				var isEmail = re.test(emailInput);
				if (!isEmail) {
					alert("You haven't selected any email.");
					return;
				}
				if (tab) {
					chrome.tabs.sendMessage(tab.id, { args: emailInput }, function (response) {
					});
				}
			} else if (info.selectionText) {
				var strData = info.selectionText;
				var emailInput = strData.trim();
				var isEmail = re.test(emailInput);
				if (!isEmail) {
					alert("You haven't selected any email.");
					return;
				}
				if (tab) {
					chrome.tabs.sendMessage(tab.id, { args: emailInput }, function (response) {
					});
				}
			}
			else {
				alert("You haven't selected any email.");
			}
		} else {
			var strData = info.selectionText;
			var emailInput = strData.trim();
			var isEmail = re.test(emailInput);
			if (!isEmail) {
				alert("You haven't selected any email.");
				return;
			}
			if (tab) {
				chrome.tabs.sendMessage(tab.id, { args: emailInput }, function (response) {
				});
			}
		}


	}

	if (info.menuItemId == "people_google") {
		if (info.selectionText == undefined) {
			alert("Please select people");
			return;
		}
		var query = info.selectionText + " site:linkedin.com/in/ OR site:linkedin.com/pub/ -site:linkedin.com/pub/dir/";
		chrome.tabs.create({ url: "http://www.google.com/search?gws_rd=cr&as_qdr=all&q=" + query });
	}

	if (info.menuItemId == "companies_google") {
		if (info.selectionText == undefined) {
			alert("Please select company");
			return;
		}
		var query = info.selectionText + " site:www.linkedin.com/company/";
		chrome.tabs.create({ url: "http://www.google.com/search?gws_rd=cr&as_qdr=all&q=" + query });
	}



});

var HEADERS_TO_STRIP_LOWERCASE = [
	'content-security-policy',
	'x-frame-options',
];
chrome.webRequest.onHeadersReceived.addListener(
	function (details) {
		return {
			responseHeaders: details.responseHeaders.filter(function (header) {
				return HEADERS_TO_STRIP_LOWERCASE.indexOf(header.name.toLowerCase()) < 0;
			})
		};
	}, {
		urls: ["https://*.agilecrm.com/*", "https://*.linkedin.com/*", "https://*.facebook.com/*","https://*.appspot.com/*", "http://*.appspot.com/*"]
	}, ["blocking", "responseHeaders"]);

var requestHeaderss = false;
chrome.tabs.onCreated.addListener(function () {
	requestHeaderss = false;
	chrome.tabs.query({
		'active': true,
		'windowId': chrome.windows.WINDOW_ID_CURRENT
	}, function (tabs) {
		if (tabs[0]) {
			var taburl = tabs[0].url;
			if (taburl.indexOf("localhost") > -1 || taburl.indexOf("agilecrm") > -1) {
				requestHeaderss = true;
			} else {
				if (taburl.indexOf("linkedin") > -1) {
					requestHeaderss = false;
				}
			}
		}
	});
});
handler = function (details) {
	chrome.tabs.query({
		'active': true,
		'windowId': chrome.windows.WINDOW_ID_CURRENT
	}, function (tabs) {
		if (tabs[0]) {
			var taburl = tabs[0].url;
			if (taburl.indexOf("localhost") > -1 || taburl.indexOf("agilecrm") > -1) {
				requestHeaderss = true;
			} else {
				if (taburl.indexOf("linkedin") > -1) {
					requestHeaderss = false;
				}
			}
		}
	});
	if (requestHeaderss) {
		for (var i = 0, l = details.requestHeaders.length; i < l; ++i) {
			if (details.requestHeaders[i].name === 'User-Agent') {
				details.requestHeaders[i].value = "Mozilla/5.0 (Linux; Android 4.0.4; Galaxy Nexus Build/IMM76B) AppleWebKit/535.19 (KHTML, like Gecko) Chrome/18.0.1025.133 Mobile Safari/535.19";
				break;
			}
		}
		return { requestHeaders: details.requestHeaders };
	}
};
chrome.webRequest.onBeforeSendHeaders.addListener(handler, { urls: ["https://*.linkedin.com/*","https://*.facebook.com/*"] }, ["blocking", "requestHeaders"]);