/**
 * Connector for connecting to various crms, as of now connects directly to AgileCRM through its developer's api.
 * **/
function CRMConnector()
{
	if(!USER_SETTINGS)
	{
		this.init_status=false;
		return;
	}
	
	var settings=USER_SETTINGS;
	
	if(settings.crm)
	{
		this.headers = { Authorization:"xx "+btoa(settings.email+':'+settings.apikey) };
		this.base_url="https://"+settings.domain+".agilecrm.com/dev/api/";
		//this.base_url="https://"+settings.domain+"-dot-sandbox-dot-agilecrmbeta.appspot.com/dev/api/";
		this.js_url='https://'+settings.domain+'.agilecrm.com/core/js/api/';
	}
	
	this.init_status=true;
}

CRMConnector.prototype.notifications=function(onLoad,cursor){
	//console.log('Running...');
	if(!cursor)cursor='';
	
	$.ajax({
		type:"GET",
		url:"http://agilecrmio.appspot.com/core/active-stream?page_size=5&cursor="+cursor,
		dataType:"json",
		success:function(response){ 
					if(response.length && response[response.length-1].stats_cursor)
					{
						response[response.length-1].next_url='http://agilecrmio.appspot.com/core/active-stream?page_size=5&cursor='+response[response.length-1].stats_cursor;
					}
					onLoad(response); 
				},
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.liveNotifications=function(onLoad){
	
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:"GET",
		url:this.base_url+"notifications",
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.upcomingTasks=function(onLoad){
	
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:"GET",
		url:this.base_url+"tasks",
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.search=function(keyword,onLoad){
	
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:"GET",
		url:this.base_url+"search/all/keyword?q="+keyword+"&page_size=5&type=person",
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
					onLoad([]);
				}
	});
};

CRMConnector.prototype.loadUrl=function(userUrl,onLoad){
	
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:"GET",
		url:userUrl,
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.loadSimpleUrl=function(userUrl,onLoad){
	$.ajax({
		type:"GET",
		url:userUrl,
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.loadTemplatesInfo=function(onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	console.log('Loading Template List');

	var url1 = this.base_url+'email/templates';
	   E_url1= encodeURI(url1);
	   console.log(E_url1);
	   var pcors1 = 'https://agile.us1.500apps.io/pcors?url='+E_url1;


	$.ajax({
		type:'GET',
		//url:this.base_url+'email/templates',
		url:pcors1,
		headers:this.headers,
		dataType:'json',
		success:function(resp){ onLoad(resp); },
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};

CRMConnector.prototype.loadTemplate=function(templateFile,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Loading Template : '+templateFile);
	$.ajax({
		type:'GET',
		url:this.base_url+'template/content?path='+encodeURIComponent('email/'+templateFile),
		headers:this.headers,
		dataType:'text',
		success:function(resp){ onLoad(resp); },
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};

CRMConnector.prototype.getContactDetails=function(emailId,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Getting info : '+emailId);
	$.ajax({
		type:'GET',
		url:this.base_url+'contacts/search/email/'+emailId,
		headers:this.headers,
		dataType:'json',
		success:function(resp){ 
			onLoad(resp); 
			//console.log('got info');
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};

CRMConnector.prototype.setLastContactEmail=function(emailId,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Getting info : '+emailId);
	$.ajax({
		type:'GET',
		url:this.base_url+'contacts/email/chrome/'+emailId,
		headers:this.headers,
		dataType:'json',
		success:function(resp){ 
			onLoad(resp); 
			//console.log('got info');
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};

CRMConnector.prototype.addContact=function(contact,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	console.log('Add contact hit :@ -----');
	//console.log(contact);
	//return;
	var contact1=contact;
	var url1 = this.base_url+'contacts';
	   E_url1= encodeURI(url1);
	   console.log(E_url1);
	   console.log('hellooooo');
	   var pcors1 = 'https://agile.us1.500apps.io/pcors?url='+E_url1;
	var contact1=contact;
	$.ajax({
		type:'POST',
		//url:this.base_url+'contacts',
		url:pcors1,
		headers:this.headers,
		data:JSON.stringify(contact),
		dataType:'jsonp',
		contentType: "application/json",
		success:function(resp){
			onLoad(resp); 
		},
		error: function(xhr,status,err){			
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.addNewContact=function(contact,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	console.log('Add contact hit : $-----');
	//console.log(contact);
	//return;
	var url1 = this.base_url+'contacts';
	   E_url1= encodeURI(url1);
	   console.log(E_url1);
	   console.log('hellooooo');
	   var pcors1 = "https://agile.us1.500apps.io/pcors?url="+url1;
	var contact1=contact;
	$.ajax({
		type:'POST',
		//url:this.base_url+'contacts',
		url:pcors1,
		headers:this.headers,
		data:JSON.stringify(contact),		
		contentType: "application/json",		
		success:function(resp){
			onLoad(resp); 
		},
		error: function(xhr,status,err){
			console.log(" *** status *** ");
			console.log(status);
			console.log(err);
			
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};


CRMConnector.prototype.updateContact=function(contact,onLoad,onError){
	if(!USER_SETTINGS.crm)return;

	$.ajax({
		type:'PUT',
		url:this.base_url+'contacts',
		headers:this.headers,
		data:JSON.stringify(contact),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			
	     	if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.addTask=function(email,task,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Add task hit : -----');
	//console.log(task);
	//return;
	
	$.ajax({
		type:'POST',
		url:this.base_url+'tasks/email/'+email,
		headers:this.headers,
		data:JSON.stringify(task),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.createTask=function(task,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Add task hit : -----');
	//console.log(task);
	//return;
	
	$.ajax({
		type:'POST',
		url:this.base_url+'tasks',
		headers:this.headers,
		data:JSON.stringify(task),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.updateTask=function(task,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Update task hit : -----');
	//console.log(task);
	//return;
	
	$.ajax({
		type:'POST',
		url:this.base_url+'tasks',
		headers:this.headers,
		data:JSON.stringify(task),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.addDeal=function(email,deal,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Add deal hit : -----');
	//console.log(deal);
	//return;

	$.ajax({
		type:'POST',
		url:this.base_url+'opportunity/email/'+email,
		headers:this.headers,
		data:JSON.stringify(deal),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.createDeal=function(deal,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	//console.log('Add deal hit : -----');
	//console.log(deal);
	//return;

	$.ajax({
		type:'POST',
		url:this.base_url+'opportunity',
		headers:this.headers,
		data:JSON.stringify(deal),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.updateContactPartial=function(contact,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:'PUT',
		url:this.base_url+'contacts/edit-properties',
		headers:this.headers,
		data:JSON.stringify(contact),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			
	     	if(typeof(onError)=='function')onError(xhr); 
		}
	});
};

CRMConnector.prototype.getEmailDetailsByDomain=function(domainInput,onLoad){
	$.ajax({
		type:"GET",
		url:"https://api.emailhunter.co/v2/domain-search?domain="+domainInput+"&api_key=5d7326bb03d64faa1443e84dd309ee2329232b59",
		dataType:"json",
		headers:this.headers,
		success:function(response){ onLoad(response); },
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
				}
	});
};

CRMConnector.prototype.getAgileVideos=function(onLoad,onError){
	if(!USER_SETTINGS.crm)return;

	var url1 = this.base_url+'video-record';
	   E_url1= encodeURI(url1);
	   console.log(E_url1);
	   var pcors1 = 'https://agile.us1.500apps.io/pcors?url='+E_url1;


	$.ajax({
		type:'GET',
		//url:this.base_url+'video-record',
		url:pcors1,
		headers:this.headers,
		dataType:'json',
		success:function(resp){ 
			onLoad(resp); 
			//console.log('got info');
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};

CRMConnector.prototype.updateContactTagsPartial=function(contact,onLoad,onError){
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:'PUT',
		url:this.base_url+'contacts/edit/tags',
		headers:this.headers,
		data:JSON.stringify(contact),
		dataType:'json',
		contentType: "application/json",
		success:function(resp){ 
			onLoad(resp); 
		},
		error: function(xhr,status,err){ 
			
	     	if(typeof(onError)=='function')onError(xhr); 
		}
	});
};
CRMConnector.prototype.addEmailTracker=function(data){
	if(!USER_SETTINGS.crm)return;
	$.ajax({
		type:'POST',
		url:this.base_url+'email-tracker/sentDetails',
		data:JSON.stringify(data),
		dataType:'json',
		contentType: "application/json",
		headers:this.headers,
		success:function(resp){ 
			console.log("message"); 
		},
		error: function(xhr,status,err){ 
			console.log('Error');
			//if(typeof(onError)=='function')onError(xhr); 
		}
	});
};


CRMConnector.prototype.updateReadStatus=function(email,subject){
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:'POST',
		url:this.base_url+'email-tracker/readStatus?email='+email+'&subject='+subject,
		dataType:"json",
		headers:this.headers,
		success:function(response){ 
			onLoad(response);
		},
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
		}
	});
};

CRMConnector.prototype.checkReadStatus=function(thread_id,onLoad){
	if(!USER_SETTINGS.crm)return;
	
	$.ajax({
		type:'POST',
		url:this.base_url+'email-tracker/readStatusCheck?thread_id='+thread_id,
		dataType:"json",
		headers:this.headers,
		contentType: "application/json",
		success:function(response){ 
			onLoad(response);
		},
		error: function (jqXHR, textStatus, errorThrown) {
					//console.log("Error - ");
		}
	});
};

CRMConnector.prototype.getEmailTrackers=function(userUrl,onLoad,onError){
	$.ajax({
		type:'GET',
		url:userUrl,
		dataType:'json',
		headers:this.headers,
		success:function(resp){ 
			onLoad(resp); 
			//console.log('got info');
		},
		error: function(xhr,status,err){ 
			//console.log('Error');
			if(typeof(onError)=='function')onError(); 
		}
	});
};