var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
var body = document.querySelector('body');

var mail_binding=[]; // array representing bound compose windows.
var mail_templates=[]; // array of email templates
var agile_video_records=[]; // array of email templates
var mail_templates_details=[]; // content of mail templates

var crm; // CRMConnector

/**
	Selectors for various components of gmail. In case gmail's UI is changed and
	the selectors fail to work, update here.
**/
var selectors={
compose_window:"td.I5",							// compose window, after binding class "agile_compose" is added
send_button:".T-I.J-J5-Ji.aoO.L3",      		// Send button (+.T-I-atl - normal send, +.T-I-ax7 - "send & archive" send)
message_box:"div.Am.Al.editable",				// div which contains message
gmail_id:"span.gbps2:first,a.gb_n.gb_K",		 	// email id of the current gmail user, "span.gbps3" works too.
subject:"input[name='subjectbox']",
mail_window:"div.ii.gt.adP.adO",
mail_tab:".gb_hc.gb_uf.gb_R"
};

var agile_send="<div id='agile_send_button'><img src='https://s3.amazonaws.com/agilecrm/panel/uploaded-logo/prabathk/png?id=uploadDocumentForm' style='vertical-align:middle;' height='18' width='18'> Send</div>";
var agile_checkbox='<div style="display: inline-block;font-family:wf_segoe-ui_semibold, Segoe UI Semibold, Segoe WP Semibold, Segoe UI, Segoe WP, Tahoma, Arial, sans-serif;font-size:12px;margin-left: 6px;margin-top: 6px;" data-tooltip="Enable Tracking with Agile CRM">\
				     <img src="https://pbs.twimg.com/profile_images/737615728338034689/eqHCsx8e_400x400.jpg" style="float: left;width: 20px;">\
				      <input style="margin-left: 19px;margin-top: 2px;width: 15px;height: 15px;position: absolute;" type="checkbox">\
				       <span style="float: left;margin-left: 40px;margin-top: 1px;">Track Mail</span>\
				      </div>\
					  ';

/**
	Binds to compose_window.
	If fails to detect send_button and message_box, sets init_status=false and returns.
	If ok, continues.
**/
function GmailComposeBindLogo(mail_tab){
	
	 this.mail_tab=$('#gbwa');
	 
	 if(!check_valid(this.mail_tab))
	 {
	  this.init_status_logo=false;
	  return;
	 }
	 this.init_status_logo=true;
	 
	 mail_tab.addClass('agile_log_tick');
	 
	 if(USER_SETTINGS.crm)
	 {
	  var tpl_bind=$('#gbwa');
	  tpl_bind = tpl_bind.parent();
	  tpl_bind.children()[0].insertAdjacentHTML('beforebegin',"<div class='gb_yc' style='display: block !important;'><a href='https://"+USER_SETTINGS.domain+".agilecrm.com' target='_blank'><img src='http://doxhze3l6s7v9.cloudfront.net/beta/static/img/agile-logo-20-20.png' style='width: 21px;border-radius: 2px;margin-top: 14px;float:left;margin-left:3px;'></a></div>");
	 }
}
function GmailComposeBind(compose_window)
{
	this.send_button=compose_window.find(selectors.send_button);
	this.message_box=compose_window.find(selectors.message_box);
	this.compose_window=compose_window;
	
	if(!check_valid(this.send_button,this.message_box))
	{
		this.init_status=false;
		return;
	}
	
	this.check_box=$(agile_checkbox);     //tick box next to send button, which enables/disables tracking
	this.agile_send_button=$(agile_send); //our own send button
	
	// copy styles from original button to our button, so it looks exactly similar
	// this.agile_send_button.attr('style',extract_css(this.send_button.get(0)));
	this.agile_send_button.addClass(this.send_button.attr('class')).css('display', 'inline-block');
	
	//this.send_button.after(this.check_box);
	this.send_button.after(this.agile_send_button);
	
	compose_window.addClass('agile_compose'); // add class to prevent binding next time
	
	this.init_status=true; // set to true, so that the caller knows it succeeded in binding
	
	// enable tracking by default if set in user preferences
	if(USER_SETTINGS && USER_SETTINGS.defaultTrack)
	{
		this.setTracked();
		this.check_box.find('input').attr('checked','ok');
	}	
	else this.setUntracked();
	
	if(USER_SETTINGS.crm)
	{
		var stylp = "<div style='background-color:whitesmoke;font-size:0.9em;height: 33px;'>\
		<select id='templateagile' class='_agileTemplate' style='width: 180px;font-family:arial,sans-serif;font-size:11px;float:right;margin-top: 7px;padding-top: 2px;padding-bottom: 2px;border-color: whitesmoke;background-color: #f9f9f9;margin-right: 5px;'><option value='-1'>Select Agile CRM Mail Template</option><option value='500' >+ Add New Template</option></select></div>";
		if($('.aoP.HM') != undefined && $('.aoP.HM').length > 0){
			stylp = "<div style='background-color:whitesmoke;font-size:0.9em;height: 33px;border-bottom: 1px solid #cfcfcf;'>\
		<select id='templateagile' class='_agileTemplate' style='width: 180px;font-family:arial,sans-serif;font-size:11px;float:right;margin-top: 7px;padding-top: 2px;padding-bottom: 2px;border-color: whitesmoke;background-color: #f9f9f9;margin-right: 5px;'><option value='-1'>Select Agile CRM Mail Template</option><option value='500' >+ Add New Template</option></select></div>";
		}
		$('.aoP.HM').css('paddingBottom', '28px');
		var tpl_bind=this.send_button.closest('table').parent().parent();
		tpl_bind.children().get(0).insertAdjacentHTML('afterend',stylp);
		this.template_binder=tpl_bind.find('select._agileTemplate');
		this.template_binder.before(this.check_box);
	}
	
	// Event handlers
	var self=this;
	
	// When checkbox is clicked, toggling between checked/unchecked
	this.check_box.click(function(){
		if(self.check_box.find(':checked').length)
			self.setTracked();
		else self.setUntracked();
	});	
	
	// When our send button is clicked, append tracking image and trigger clicking of original send button
	this.agile_send_button.click(function(){
		
		//self.send_button.trigger("click");
		var to = self.compose_window.find("input[name='to']").prev('span').attr('email');
		var fullName = $('.vT')[0].innerText.replace(/ *\([^)]*\) */g, "");;
		
		
		
		var contact = {};
		var properties = [];
		var last_contacted = 0;
		var last_emailed = 0;
		last_contacted = Math.floor( Date.now() / 1000 );
		last_emailed = Math.floor( Date.now() / 1000 );
		var emailProperty = {};
		emailProperty.name = 'email';
		emailProperty.type = 'SYSTEM';
		emailProperty.value = to;
		properties.push(emailProperty);
		contact.properties = properties;
		
		if(fullName){
			
			var StrObj = fullName;
			var emailsArray = StrObj.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
			if(!emailsArray){
				var fullNameSplited = fullName.split(/\s+/);
				var arr = [fullNameSplited.shift(), fullNameSplited.join(' ')];
				var firstName = arr[0];
				var lastName = arr[1];
				
				var fnameProperty = {};
				fnameProperty.name = 'first_name';
				fnameProperty.type = 'SYSTEM';
				fnameProperty.value = firstName;
				
				properties.push(fnameProperty);
				contact.properties = properties;
				
				var lnameProperty = {};
				lnameProperty.name = 'last_name';
				lnameProperty.type = 'SYSTEM';
				lnameProperty.value = lastName;
				
				properties.push(lnameProperty);
				contact.properties = properties;
			}
			}
		
		
		contact.last_contacted=last_contacted;
		contact.last_emailed=last_emailed;
		crm.addContact(contact, function(resp){
			var resp;
			self.appendTrackingMessage();
			self.send_button.trigger("click");
			
		},function(resp){
			var resp;
			if(resp.responseText=="Sorry, duplicate contact found with the same email address."){
				crm.setLastContactEmail(to, function(resp){
				},function(resp){
					
				});
			}
			self.appendTrackingMessage();
			self.send_button.trigger("click");
			
		});
	});
	
	this.compose_window.get(0).addEventListener('keydown',function(e){
		if(e.which === 13 && (e.metaKey || e.ctrlKey)){ //enter key
				self.appendTrackingMessage();
				return true;
		}
	},true);
	
	this.removeTrackingMessage();
	
}

// enable tracking, hide original send button, show our button
GmailComposeBind.prototype.setTracked=function(){
	chrome.storage.local.get(null,function(item){
		USER_SETTINGS=item.USER_SETTINGS;
		USER_SETTINGS.defaultTrack=true;
		chrome.storage.local.set({'USER_SETTINGS': USER_SETTINGS});
	});  
	this.send_button.hide();
	this.agile_send_button.show();
	
};

// disable tracking, reverse of setTracked()
GmailComposeBind.prototype.setUntracked=function(){
	chrome.storage.local.get(null,function(item){
		USER_SETTINGS=item.USER_SETTINGS;
		USER_SETTINGS.defaultTrack=false;
		chrome.storage.local.set({'USER_SETTINGS': USER_SETTINGS});
	});
	this.send_button.show();
	this.agile_send_button.hide();
	
};

// appends tracking image
GmailComposeBind.prototype.appendTrackingMessage=function(){
	
	var subject = this.compose_window.find("input[name='subjectbox']").val();
	var to = this.compose_window.find("input[name='to']").prev('span').attr('email');
	var time = (new Date()).getTime();
	var randomNum = Math.floor(Math.random() * 1000000000);
	var url = "https://"+USER_SETTINGS.domain+".agilecrm.com/open?e="+to+"&d="+subject+"&fr="+USER_SETTINGS.email+"&s="+time+"&er="+randomNum;
	this.message_box.find('div#crmio-track').remove();
	this.message_box.append('<div id="crmio-track" class="crm-img"></div>');
	this.message_box.find('div#crmio-track').html('<img src="'+url+'" nosend="1" align="left" width="0" height="0" style="border:0;width:0px;height:0px;opacity:0;" alt=""></img>');
	
}

// remove tracking image
GmailComposeBind.prototype.removeTrackingMessage=function(){
	
	this.message_box.find('div#crmio-track').remove();
}

GmailComposeBind.prototype.agileTemplates=function(){
	if(!this.template_binder)return;
	
	var str='';
	var str1='';
	for(var i=0;i<mail_templates.length;++i)
	 {
	  str+="<option value='"+i.toString()+"' style='color: #78909c;'>"+mail_templates[i].name+"</option>";
	 }
	 if(mail_templates.length >0){
	  str ="<optgroup label='Templates'>"+str+"</optgroup>";
	 }
	 for(var i=0;i<agile_video_records.length;++i)
	 {
	  str1+="<option value='100"+i.toString()+"' style='color: #78909c;'>"+agile_video_records[i].name+"</option>";
	 }
	 if(agile_video_records.length > 0){
	  str1 ="<optgroup label='Videos'>"+str1+"</optgroup>";
	 }
	 
	this.template_binder.append(str+str1);
	
	var base=this;
	
	this.template_binder.on("change",function(){
		try{
			var idx = parseInt(this.value);
			if(idx == 500){
				$("#templateagile").val('-1');
				window.open('https://'+USER_SETTINGS.domain+'.agilecrm.com/#emailbuilder-templates', "_blank");
			}
			if(idx<0) base.fillTemplate();		
			else base.fillTemplate(idx);
			
		}catch(err){}
	});	
};

GmailComposeBind.prototype.fillTemplate=function(tplIdx){

	if(tplIdx==undefined || tplIdx<0)
	{	
		if(this.default_mail){
			this.message_box.html(this.default_mail);
			this.compose_window.find("input[name='subjectbox']").val("");
		}
		return;	
	}
	
	if(!this.default_mail)
		this.default_mail=this.message_box.html();
	
	if(tplIdx >= 1000){
		tplIdx = tplIdx - 1000;
		if(agile_video_records[tplIdx])
		{
			var athumb_url = agile_video_records[tplIdx].thumb_url;
			var aurl = agile_video_records[tplIdx].url;
			var aid = agile_video_records[tplIdx].id;
			var videohtml = getAgileCRMVideoHTML(athumb_url,aurl,aid);
			this.message_box.html(videohtml);
			this.message_box.focus();
		}
	}else{
		if(mail_templates[tplIdx])
		{
			this.message_box.html(getHTML(mail_templates[tplIdx].text,{},true));
			this.compose_window.find("input[name='subjectbox']").val(mail_templates[tplIdx].subject);
			this.message_box.focus();
		}
	}
};

/**
 * Get video template.
 */
function getAgileCRMVideoHTML(athumb_url,aurl,aid)
{
	var fxn = "<br/><!DOCTYPE html>\
			<html lang='en'>\
			<body><div style='padding: 10px 10px 10px 10px;'><a target='_blank' class='mgLink' href='https://"+USER_SETTINGS.domain+".agilecrm.com/video/"+aid+"'><img class='' data-maxwidth='520' border='0' align='one_image' style='display:block;max-width:320px;' alt='' src='"+athumb_url+"' tabindex='0' width='320' height='240' id='b619ffa3-d469-0fc5-76f0-a9e4bb557be0'></a></div></body>\
			</html><br/>";
	
	return fxn;
}

/**
 * Remove the custom fields from the templates using handlebars.
 */
function getHTML(tpl,data,isTemplate)
{
		var template = "";
		var fxn = "";
		if(isTemplate)
		{
			if(data)
				template = Mustache.to_html(tpl,data);
			else
				template = Mustache.to_html(tpl);

			return template;
		}
		else
		{
			fxn = Handlebars.compile(template);
			
			if(Object.prototype.toString.call(data)==='[object Array]')
			{
				return fxn( {length:data.length, content:data} );
			}
			return fxn(data);
		}		
}

/** Registering tab, so as to know from which tabs, image request should be blocked **/
var isRegistered=false;

function registerTab(isForced)
{
	if(isRegistered && !isForced)return;
	
	chrome.runtime.sendMessage({from:'_crmio_gmail_content',msg:'register'},function(resp){isRegistered=true;});
}

function unregisterTab()
{
	if(!isRegistered)return;
	
	chrome.runtime.sendMessage({from:'_crmio_gmail_content',msg:'unregister'},function(resp){isRegistered=false;});
}

/**
 * Extract Gmail Id from title.
 **/ 
function getCurrentGmailId()
{	
	var title=document.querySelector("head>title").innerHTML;
	
	if(!title)return '';
	
	var idx=title.indexOf("-");
	
	if(idx<=0)return '';
	
	current_gmail_id='';
	
	for(var i=idx+2;title[i]!=' ' && i<title.length;++i)
		current_gmail_id+=title[i];
		
	if(current_gmail_id.indexOf('@')==-1)
			return '';
		
	return current_gmail_id;	
}

var mail_observer = new MutationObserver(function(i){
	//console.log('BOUND - Observing user mails.');
	if(USER_SETTINGS && USER_SETTINGS.email)
	{
		var image_link = 'fr='+USER_SETTINGS.email;
		$(selectors.mail_window).each(function(){
			$(this).find('img').each(function(){
				if($(this).attr('src').contains(image_link))
					$(this).remove();
			});
		});
	}
});

/** MutationObserver for the body,
	Accumulates results, ran fewer times that domNodeInserted.
	
	Checks if this email-id is allowed in preferences.
	Binds to each compose window.
**/
var compose_observer=new MutationObserver(function(m){
	
	registerTab();
	
	$(selectors.compose_window).not(".agile_compose").each(function(){
		var gmail_bind=new GmailComposeBind($(this));	
			
		if(gmail_bind.init_status)
		{	
			mail_binding.push(gmail_bind);
			
			/*if(!crm && USER_SETTINGS.crm && mail_templates.length==0)*/
			if(USER_SETTINGS.crm && mail_templates.length==0)
			{	
				crm=new CRMConnector();
				
				crm.loadTemplatesInfo(function(data){
					crm.getAgileVideos(function(data1){
					data.sort(function(a, b){
						if(a.name.toLowerCase() < b.name.toLowerCase()) return -1;
						if(a.name.toLowerCase() > b.name.toLowerCase()) return 1;
						return 0;
					});
					data1.sort(function(a, b){
						if(a.name.toLowerCase() < b.name.toLowerCase()) return -1;
						if(a.name.toLowerCase() > b.name.toLowerCase()) return 1;
						return 0;
					});
					mail_templates=data;
					agile_video_records=data1;
					gmail_bind.agileTemplates();
					});
				});
			}
			else if(mail_templates.length>0)
			{
				gmail_bind.agileTemplates();
			}else if(crm && USER_SETTINGS.crm && mail_templates.length==0){
				gmail_bind.agileTemplates();
			}	
		}
	});
	
	$('#gbwa').not(".agile_log_tick").each(function(){
    var gmail_bind_logo=new GmailComposeBindLogo($(this)); 
   
   });
	
});

compose_observer.observe(body,{attributes:true,childList:true});

/** Load templates **/

