var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
var body = document.querySelector('body');

var mail_binding=[]; // array representing bound compose windows.
var mail_templates=[]; // array of email templates
var mail_templates_details=[]; // content of mail templates


var crm; // CRMConnector


var agile_send="<div id='agile_send_button'><img src='https://s3.amazonaws.com/agilecrm/panel/uploaded-logo/prabathk/png?id=uploadDocumentForm' style='vertical-align:middle;' height='18' width='18'> Send</div>";
var agile_checkbox='<div style="display: inline-block;font-family:wf_segoe-ui_semibold, Segoe UI Semibold, Segoe WP Semibold, Segoe UI, Segoe WP, Tahoma, Arial, sans-serif;font-size:12px;margin-left: 6px;margin-top: 6px;" data-tooltip="Enable Tracking with Agile CRM">\
				     <img src="https://pbs.twimg.com/profile_images/737615728338034689/eqHCsx8e_400x400.jpg" style="float: left;width: 20px;">\
				      <input style="margin-left: 19px;margin-top: 2px;width: 15px;height: 15px;position: absolute;" type="checkbox">\
				       <span style="float: left;margin-left: 40px;margin-top: 1px;">Track Mail</span>\
				      </div>\
					  ';
/**
	Binds to compose_window.
	If fails to detect send_button and message_box, sets init_status=false and returns.
	If ok, continues.
**/
function GmailComposeBind(compose_window)
{
	this.send_button=calculateSendButton();
	this.send_button2 = $('.allowTextSelection div[role="region"]');
	this.message_box=calculateMessageButton();
	this.compose_window=compose_window;
	
	
	this.check_box=$(agile_checkbox);     
	this.agile_send_button=$(agile_send); 
	
	this.agile_send_button.attr('style','margin-top: 3px;padding: 5px 11px 0px; background: rgb(0, 120, 215); font-size: 13px;  font-weight: bold; border-color: rgb(0, 120, 215); color: rgb(255, 255, 255); box-sizing: border-box; border-width: 1px; border-style: solid; height: 30px; float: left; display: block; margin-right: 10px; cursor: pointer !important;');
	
	
	this.send_button.after(this.agile_send_button);
	
	compose_window.addClass('agile_compose'); 
	
	this.init_status=true; // set to true, so that the caller knows it succeeded in binding
	
	// enable tracking by default if set in user preferences
	if(USER_SETTINGS && USER_SETTINGS.defaultTrack)
	{
		this.setTracked();
		this.check_box.find('input').attr('checked','ok');
	}	
	else this.setUntracked();
	
	if(USER_SETTINGS.crm)
	{
		var tpl_bind=this.send_button2;
		tpl_bind.parent().get(0).insertAdjacentHTML('afterbegin',"<div class='agile_compose_bar' style='background-color:whitesmoke;'><select class='_agileTemplate' style='width: 180px;font-family:arial,sans-serif;font-size:11px;float:right;margin-top: 7px;padding-top: 2px;padding-bottom: 2px;border-color: whitesmoke;background-color: #f9f9f9;margin-right: 19px;'><option value='-1'>Select Agile CRM Mail Template</option></select></div>");
		this.template_binder=tpl_bind.parent().find('select._agileTemplate');
		this.template_binder.before(this.check_box);
	}
	
	// Event handlers
	var self=this;
	
	// When checkbox is clicked, toggling between checked/unchecked
	this.check_box.click(function(){
		if(self.check_box.find(':checked').length)
			self.setTracked();
		else self.setUntracked();
	});	
	
	// When our send button is clicked, append tracking image and trigger clicking of original send button
	this.agile_send_button.click(function(){
		
		var e = getToEmailsOutLook();
		var emailArr = [];

		var em = '';
		if(e && e.length >0){
			for(var k =0; k<e.length; k++){
			var input = e[k];
			if(input.indexOf('@') > 1){
				emailArr.push(input);
			}else{
			//$('.conductorContent input[role="textbox"]').trigger("click")[2];
			self.send_button.trigger("click");
			$('.agile_compose_bar').remove();
			return;
			}
		}
		}else{
			return;
		}
		
		var to = emailArr[0];
		var firstname = to.split("@")[0];
		var contact = getParsedContact(to,firstname);	
			
			
		self.appendTrackingMessage(to);
		self.send_button.trigger("click");
			//createContactForEachIteration(contact);
		crm.addContact(contact, function(resp){
			var resp;
		},function(resp){
			var resp;
			if(resp.responseText=="Sorry, duplicate contact found with the same email address."){
				crm.setLastContactEmail(to, function(resp){
				},function(resp){
					
				});
			}
		});		
		
	});
	
	this.compose_window.get(0).addEventListener('keydown',function(e){
		if(e.which === 13 && (e.metaKey || e.ctrlKey)){ //enter key
				self.appendTrackingMessage();
				return true;
		}
	},true);
	
	this.removeTrackingMessage();
	
}

function OutlookComposeBind(compose_window)
{

	compose_window.addClass('outlook_compose'); // add class to prevent binding next time
	
	//this.init_status=true; // set to true, so that the caller knows it succeeded in binding
	
	if(USER_SETTINGS.crm)
	{
		var tpl_bind=$('.o365cs-nav-centerAlign');
		tpl_bind.children()[0].insertAdjacentHTML('beforebegin',"<div style='margin-right: 7px;border-left: 1px solid #4c4c4c;width: 43px;float: right;height: 50px;'><a href='https://"+USER_SETTINGS.domain+".agilecrm.com' target='_blank'><img src='https://doxhze3l6s7v9.cloudfront.net/img/agile-cloude-icon-svg.svg' style='width: 20px;padding-top: 14px;padding-left: 9px;'></a></div>");
	}
	
}

// enable tracking, hide original send button, show our button
GmailComposeBind.prototype.setTracked=function(){
	chrome.storage.local.get(null,function(item){
		USER_SETTINGS=item.USER_SETTINGS;
		USER_SETTINGS.defaultTrack=true;
		chrome.storage.local.set({'USER_SETTINGS': USER_SETTINGS});
	});  
	this.send_button.hide();
	this.agile_send_button.show();
	
};

// disable tracking, reverse of setTracked()
GmailComposeBind.prototype.setUntracked=function(){
	chrome.storage.local.get(null,function(item){
		USER_SETTINGS=item.USER_SETTINGS;
		USER_SETTINGS.defaultTrack=false;
		chrome.storage.local.set({'USER_SETTINGS': USER_SETTINGS});
	});
	this.send_button.show();
	this.agile_send_button.hide();
	
};

// appends tracking image
GmailComposeBind.prototype.appendTrackingMessage=function(emailRecived){
	
	var subject = $('.conductorContent input[role="textbox"][aria-label]').val();
	var to = emailRecived;
	var time = (new Date()).getTime();
	var url = "https://"+USER_SETTINGS.domain+".agilecrm.com/open?e="+to+"&d="+subject+"&fr="+USER_SETTINGS.email+"&s="+time;
	this.message_box.find('div#crmio-track').remove();
	this.message_box.append('<div id="crmio-track"></div>');
	this.message_box.find('div#crmio-track').html('<img src="'+url+'" nosend="1" width="1" height="1"></img>');
	
}

// remove tracking image
GmailComposeBind.prototype.removeTrackingMessage=function(){
	
	this.message_box.find('div#crmio-track').remove();
}

GmailComposeBind.prototype.agileTemplates=function(){
	if(!this.template_binder)return;
	
	var str='';
	
	for(var i=0;i<mail_templates.length;++i)
	{
		str+="<option value='"+i.toString()+"'>"+mail_templates[i].name+"</option>";
	}
	
	this.template_binder.append(str);
	
	var base=this;
	
	this.template_binder.on("change",function(){
		try{
			var idx = parseInt(this.value);
			if(idx<0) base.fillTemplate();		
			else base.fillTemplate(idx);
			
		}catch(err){}
	});	
};

GmailComposeBind.prototype.fillTemplate=function(tplIdx){

	if(tplIdx==undefined || tplIdx<0)
	{	
		if(this.default_mail){
			this.message_box.html(this.default_mail);
			$('.conductorContent input[role="textbox"][aria-label]').val("");
		}
			
		return;	
	}
	
	if(!this.default_mail)
		this.default_mail=this.message_box.html();
	
	if(mail_templates[tplIdx])
	{
		this.message_box.html(getHTML(mail_templates[tplIdx].text,{}));
		this.compose_window=$('.conductorContent input[role="textbox"][aria-label]');;
		this.compose_window.val(mail_templates[tplIdx].subject);
		this.compose_window.focus();
		this.message_box.focus();
	}
};

/**
 * Remove the custom fields from the templates using handlebars.
 */
function getHTML(tpl,data)
{
	var fxn=Handlebars.compile(tpl);
	
	if(Object.prototype.toString.call(data)==='[object Array]')
	{
		return fxn( {length:data.length, content:data} );
	}
	
	return fxn(data);
}

/** Registering tab, so as to know from which tabs, image request should be blocked **/
var isRegistered=false;

function registerTab(isForced)
{
	if(isRegistered && !isForced)return;
	
	chrome.runtime.sendMessage({from:'_crmio_gmail_content',msg:'register'},function(resp){isRegistered=true;});
}

function unregisterTab()
{
	if(!isRegistered)return;
	
	chrome.runtime.sendMessage({from:'_crmio_gmail_content',msg:'unregister'},function(resp){isRegistered=false;});
}

function isOutlookMailOfAgile() {
    var t = ("" + window.location).toLowerCase();
    return t.indexOf("path=/mail") > -1 || t.indexOf("projection.aspx") > -1 || "https://outlook.office.com/owa/" === t || $("#MailFolderPane\\.FavoritesFolders").length > 0
}

function calculateSendButton(){
//var x = isOutlookMail();
var c="";	

var m = $('.conductorContent div[role="toolbar"][aria-label]');
if(0 !== m.length){
	e = $(m);
	e.closest(".scrollContainer").css("z-index", 1e3);
	c = e.find("button").eq(0);

} 
return c;
}

function calculateMessageButton(){
var c="";	

var m = $('.conductorContent div[role="toolbar"][aria-label]');
if(0 !== m.length){
	e = $(m);
	
	c = $('.conductorContent div[role="textbox"][aria-label]');

} 
return c;
}

function getFirstEmailOutLook(){
var c="";	

var t = $(".agile_compose_bar").closest(".conductorContent").find("div[role=combobox]").eq(0).find("div[aria-haspopup=true]");
var i = t[0];
c = $(i).find("span.allowTextSelection[autoid]").text();
return c;
}

/**
* Returns All To Emails of compose body
*/
function getToEmailsOutLook(){

var $container = $('.conductorContent div[role="toolbar"][aria-label]').closest(".scrollContainer"), $to;
$to = $container.find("div[role=presentation]").eq(0).find("div[aria-haspopup=true]");

if(!$to.length)		 
	$to = $container.find("div.allowTextSelection:first .PersonaPaneLauncher");

var arr = [];
for(var j=0; j < $to.length ; j++){
	arr.push($($to[j]).find("span.allowTextSelection[autoid]").text());
}

return arr;

}

function getParsedContact(to,firstname){
	var contact = {};
	var properties = [];
	var last_contacted = 0;
	var last_emailed = 0;
	last_contacted = Math.floor( Date.now() / 1000 );
	last_emailed = Math.floor( Date.now() / 1000 );
	if(to.length > 1){
		var emailProperty = {};
		emailProperty.name = 'email';
		emailProperty.type = 'SYSTEM';
		emailProperty.value = to;
		properties.push(emailProperty);
		contact.properties = properties;
	}
	
	if(firstname.length > 1){
		var fnameProperty = {};
		fnameProperty.name = 'first_name';
		fnameProperty.type = 'SYSTEM';
		fnameProperty.value = firstname;
					
		properties.push(fnameProperty);
		contact.properties = properties;
	}
				
	contact.last_contacted=last_contacted;
	contact.last_emailed=last_emailed;
	return contact;
}

/**
 * Extract Gmail Id from title.
 **/ 
function getCurrentGmailId()
{	
	var title=document.querySelector("head>title").innerHTML;
	
	if(!title)return '';
	
	var idx=title.indexOf("-");
	
	if(idx<=0)return '';
	
	current_gmail_id='';
	
	for(var i=idx+2;title[i]!=' ' && i<title.length;++i)
		current_gmail_id+=title[i];
		
	if(current_gmail_id.indexOf('@')==-1)
			return '';
		
	return current_gmail_id;	
}

var mail_observer = new MutationObserver(function(i){
	if(USER_SETTINGS && USER_SETTINGS.email)
	{
		var image_link = 'fr='+USER_SETTINGS.email;
		$(selectors.mail_window).each(function(){
			$(this).find('img').each(function(){
				if($(this).attr('src').contains(image_link))
					$(this).remove();
			});
		});
	}
});

/** MutationObserver for the body,
	Accumulates results, ran fewer times that domNodeInserted.
	
	Checks if this email-id is allowed in preferences.
	Binds to each compose window.
**/
var compose_observer=new MutationObserver(function(m){
	
	if(isOutlookMailOfAgile()){
		var selectors={
		compose_window:$('.conductorContent div[role="toolbar"][aria-label]').closest(".scrollContainer").css("z-index", 1e3),
		send_button:calculateSendButton(),	

		message_box:calculateMessageButton(),
		
		send_button2:$('.allowTextSelection div[role="region"]'),
		
		subject:"input_mcp_R2._mcp_S2.ms-font-weight-regular.ms-bg-color-white-hover.ms-font-color-neutralPrimary.allowTextSelection._mcp_P2.textbox.ms-font-s.ms-fwt-sl.ms-fcl-np.ms-bcl-nta.ms-bcl-nsa-h",
		//mail_window:"div.ii.gt.adP.adO"
		};
		
		var outlookAgileLogo={
			outlookagileLogoBar:$('.o365cs-nav-centerAlign'),
		}
	}
	
	
	
	registerTab();
	if(outlookAgileLogo != undefined && outlookAgileLogo.outlookagileLogoBar != undefined){
		$(outlookAgileLogo.outlookagileLogoBar).not(".outlook_compose").each(function(){
			var outlook_bind=new OutlookComposeBind($(this));	
		});	
	}
	
	if(selectors != undefined && selectors.compose_window != undefined){
		$(selectors.compose_window).not(".agile_compose").each(function(){
		
			var gmail_bind=new GmailComposeBind($(this));	
				
			if(gmail_bind.init_status)
			{	
				mail_binding.push(gmail_bind);
				
				if(!crm && USER_SETTINGS.crm && mail_templates.length==0)
				{	
					crm=new CRMConnector();
					
					crm.loadTemplatesInfo(function(data){
						data.sort(function(a, b){
							if(a.name.toLowerCase() < b.name.toLowerCase()) return -1;
							if(a.name.toLowerCase() > b.name.toLowerCase()) return 1;
							return 0;
						});
						mail_templates=data;
						gmail_bind.agileTemplates();
					});
				}
				else if(mail_templates.length>0)
				{
					gmail_bind.agileTemplates();
				}	
			}
		});	
	}	
	
});

compose_observer.observe(body,{attributes:true,childList:true});

/** Load templates **/